import es
import gamethread
import popuplib

updaterate = 1 # How often the menu should update (in seconds)
style = 1 # The style the spectators are shown ( 1 = hud hint, 2 = popup, 3 = toptext [You can set the updaterate pretty high with toptext])
max_length = 8 # The maximum length a name may have (Will be shortened otherwise: Absolute123 would be shortened to Absolu..)
advert_time = 120 # The time between the adverts (in seconds)

info = es.AddonInfo()
info.author      = "AbSoLuTe"
info.name        = "Tell Spectator names"
info.basename    = "tellspec"
info.version     = "1.1"
info.url         = "http://addons.eventscripts.com/addons/view/%s"%info.basename
info.description = "Shows your current spectators" 

es.ServerVar(info.basename, info.version, info.description + " made by " + info.author).makepublic()

enabled = []
advert = 0
update_in_sec = 1 / updaterate
advert_time = advert_time * update_in_sec

def load():
    es.regsaycmd('!disable',"%s/disabled"%info.basename,"Disables or Enables the Menu")
    
def unload():
    es.unregsaycmd('!disable')
    
def disabled():
    uid = int(es.getcmduserid())
    if uid in enabled:
        es.tell(uid,"#multi","#greenYou will no longer see the spectator menu")
        enabled.remove(uid)
    else:
        es.tell(uid,"#multi","#greenYou see the spectator menu again")
        enabled.append(uid)

def player_connect(event_var):
    uid = int(event_var['userid'])
    enabled.append(uid)
def player_disconnect(event_var):
    uid = int(event_var['userid'])
    if uid in enabled:
        enabled.remove(uid)

def checkloop():
    global advert
    if not advert:
        advert = 0
    advert = advert + 1
    if advert >= advert_time:
        advert = 0
        es.msg("#multi","#greenType #lightgreen'!disable'#green to toggle the spectator menu. Written by #lightgreenAbSoLuTe#green.")
    ulist = es.getUseridList()
    for uid in enabled:
        if es.getplayersteamid(uid) == "BOT":
            continue
        if not es.getplayerprop(uid, "CCSPlayer.baseclass.pl.deadflag"):
            ulist.remove(uid)
            spectators = ""
            temp = 0
            comparehandle = es.getplayerhandle(uid)
            for specs in ulist:
                if int(es.getplayerprop(specs, "CCSPlayer.baseclass.m_iObserverMode")) in (1,3,4):
                    if es.getplayerprop(specs, 'CBasePlayer.m_hObserverTarget') == comparehandle:
                        ulist.remove(specs)
                        if len(es.getplayername(specs)) > max_length:
                            realname = es.getplayername(specs)[:max_length-2] + ".."
                        else:
                            realname = es.getplayername(specs)
                        if style == 3:
                            spectators = spectators + ", " + realname
                        elif style == 2:
                            spectators = spectators + "\n  " + realname
                        elif style == 1:
                            temp = temp + 1
                            if temp == 4:
                                temp = 0
                                spectators = spectators + "\n" + realname
                            else:
                                spectators = spectators + ", " + realname
                else:
                    ulist.remove(specs)
            if spectators:
                if style == 3:
                    es.toptext(uid,updaterate,"#grey","Your Spectators: " + spectators[1:])
                elif style == 2:
                    es.menu(updaterate, uid, "Your Spectators:" + spectators + "\nType !disable to disable")
                elif style == 1:
                    es.usermsg('create', 'hud', 'HintText')
                    es.usermsg('write',  'byte',       'hud', -1)
                    es.usermsg('write',  'string',     'hud', "Your Spectators:\n" + spectators[1:])
                    es.usermsg('send',   'hud', uid)
                    es.usermsg('delete', 'hud')
          
    gamethread.delayed(updaterate,checkloop)
   
checkloop()